apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "don.fullname" . }}
  labels:
    {{- include "don.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "don.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "don.selectorLabels" . | nindent 8 }}
      annotations:
        checksum/secret: {{ include (print $.Template.BasePath "/secret.yaml") . | sha256sum }}
      {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
    spec:
      serviceAccountName: {{ include "don.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: python
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: {{ printf "%s:%s" .Values.image.repository .Values.image.tag }}
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 8000
              protocol: TCP
          startupProbe:
            tcpSocket:
              port: http
          readinessProbe:
            tcpSocket:
              port: http
          env:
            {{- include "don.djangoBaseEnvironment" . | nindent 12 }}
            - name: ALLOWED_HOST
              value: {{ printf ".%s" .Values.ingress.host | quote }}
            - name: GITLAB_URL
              value: {{ .Values.config.gitlabURL }}
            - name: GITLAB_PROJECT_ID
              value: {{ .Values.config.gitlabProjectID | quote }}
            - name: GITLAB_ACCESS_TOKEN
              valueFrom:
                secretKeyRef:
                  name: {{ include "don.fullname" . }}
                  key: gitlab-access-token
            - name: INFLUXDB_URL
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.metricsExistingInfluxDBSecret }}
                  key: url
            - name: INFLUXDB_TOKEN
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.metricsExistingInfluxDBSecret }}
                  key: token
          {{- if .Values.config.goatcounterEnabled }}
            - name: GOATCOUNTER_ENABLED
              value: "true"
          {{- end }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
